# module ActiveSupport::Testing::SetupAndTeardown::ForClassicTestUnit

### Constants

PASSTHROUGH_EXCEPTIONS

  For compatibility with Ruby < 1.8.6

### Public Instance Methods

run(result) { |STARTED, name| ... } click to toggle source

This redefinition is unfortunate but test/unit shows us no alternative. Doubly unfortunate: hax to support Mocha’s hax.

    # File lib/active_support/testing/setup_and_teardown.rb, line 56
    def run(result)
      return if @method_name.to_s == "default_test"

      mocha_counter = retrieve_mocha_counter(result)
      yield(Test::Unit::TestCase::STARTED, name)
      @_result = result

      begin
        begin
          run_callbacks :setup do
            setup
            __send__(@method_name)
            mocha_verify(mocha_counter) if mocha_counter
          end
        rescue Mocha::ExpectationError => e
          add_failure(e.message, e.backtrace)
        rescue Test::Unit::AssertionFailedError => e
          add_failure(e.message, e.backtrace)
        rescue Exception => e
          raise if PASSTHROUGH_EXCEPTIONS.include?(e.class)
          add_error(e)
        ensure
          begin
            teardown
            run_callbacks :teardown
          rescue Test::Unit::AssertionFailedError => e
            add_failure(e.message, e.backtrace)
          rescue Exception => e
            raise if PASSTHROUGH_EXCEPTIONS.include?(e.class)
            add_error(e)
          end
        end
      ensure
        mocha_teardown if mocha_counter
      end

      result.add_run
      yield(Test::Unit::TestCase::FINISHED, name)
    end